Bug 1794229 - Review Request: rubygem-rspec-fire - More resilient test doubles for RSpec.
Summary: Review Request: rubygem-rspec-fire - More resilient test doubles for RSpec.
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
unspecified
medium
Target Milestone: ---
Assignee: Alejandro Alvarez
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2020-01-23 00:12 UTC by Breno
Modified: 2020-02-22 02:35 UTC (History)
2 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2020-02-22 02:35:01 UTC
Type: ---
a.alvarezayllon: fedora-review+


Attachments (Terms of Use)

Description Breno 2020-01-23 00:12:48 UTC
Spec URL: https://github.com/skywalkerz0r/rubygem-rspec-fire
SRPM URL: https://copr-be.cloud.fedoraproject.org/results/brandfbb/puppet-6-on-EPEL-8-with-deps/epel-8-x86_64/01155216-rubygem-rspec-fire/rubygem-rspec-fire-1.3.0-1.el8.src.rpm

Description:
This package is a requirement in order to have puppet 6 in EPEL 8.
I know this package is old and obsolete but is required for rubygem-cane, which is required by semantic_puppet that is required by puppet.


The build was tested on copr[1].

I am in the packager group, sponsored by nirik and my mentor is smooge.

1 - https://copr.fedorainfracloud.org/coprs/brandfbb/puppet-6-on-EPEL-8-with-deps/package/rubygem-rspec-fire/

Thanks.

Fedora Account System Username: brandfbb

Comment 1 Breno 2020-01-31 15:00:23 UTC
I noted some mistakes, I've just updated both Spec and SRPM.
Please let me know if there's anything else I should fix.

Spec URL: https://github.com/skywalkerz0r/rubygem-rspec-fire/blob/epel8/rubygem-rspec-fire.spec
SRPM URL: https://copr-be.cloud.fedoraproject.org/results/brandfbb/puppet-6-on-EPEL-8-with-deps/epel-8-x86_64/01213467-rubygem-rspec-fire/rubygem-rspec-fire-1.3.0-1.el8.src.rpm

Description:
This package is a requirement in order to have puppet 6 in EPEL 8.


The build was tested on copr[1].

I am in the packager group, sponsored by nirik and my mentor is smooge.

1 - https://copr.fedorainfracloud.org/coprs/brandfbb/puppet-6-on-EPEL-8-with-deps/package/rubygem-rspec-fire/

Thanks.

Fedora Account System Username: brandfbb

Comment 2 Alejandro Alvarez 2020-02-04 13:59:44 UTC
Hi,

It is better if you point to the raw spec file, not the gihub page, otherwise fedora-review can not process it (I have done this in the past too!)

I have checked the spec file from the source rpm and the one you give and the changelogs are different:

< * Wed Dec 18 2019 Breno Brand Fernandes <brandfbb@gmail.com> - 3.3.2-14
---
> * Wed Dec 18 2019 Breno Brand Fernandes <brandfbb@gmail.com> - 1.3.0-1


I guess a C&P error from some other rpm? Can you provide another source rpm built with the right spec?

rpmlint:

rubygem-rspec-fire.noarch: W: summary-ended-with-dot C More resilient test doubles for RSpec.
rubygem-rspec-fire.noarch: W: incoherent-version-in-changelog 3.3.2-14 ['1.3.0-1.el8', '1.3.0-1']
rubygem-rspec-fire.src: W: summary-ended-with-dot C More resilient test doubles for RSpec.
3 packages and 0 specfiles checked; 0 errors, 3 warnings.

Note the "incoherent-version-in-changelog"

fedora-review complains about "[!]: Test suite of the library should be run.", but from what I can see this package does not seem to have tests.

You should drop the dependency on ruby: https://docs.fedoraproject.org/en-US/packaging-guidelines/Ruby/

* There SHOULD NOT be Requires: ruby(release), unless you want to explicitly specify Ruby version compatibility. The automatically generated dependency on RubyGems (Requires: ruby(rubygems)) is enough.


Similarly 

* There SHOULD NOT be any rubygem Requires nor Provides listed, since those are autogenerated.


As it is now, the resulting rpms do not seem to be installable:

Error: 
 Problem 1: conflicting requests
  - nothing provides (rubygem(rspec) < 4 with rubygem(rspec) >= 2.11) needed by rubygem-rspec-fire-1.3.0-1.el8.noarch
  - nothing provides rubygem-rspec >= 2.11 needed by rubygem-rspec-fire-1.3.0-1.el8.noarch
  - nothing provides rubygem-rspec < 4 needed by rubygem-rspec-fire-1.3.0-1.el8.noarch
 Problem 2: package rubygem-rspec-fire-doc-1.3.0-1.el8.noarch requires rubygem-rspec-fire = 1.3.0-1.el8, but none of the providers can be installed
  - conflicting requests
  - nothing provides (rubygem(rspec) < 4 with rubygem(rspec) >= 2.11) needed by rubygem-rspec-fire-1.3.0-1.el8.noarch
  - nothing provides rubygem-rspec >= 2.11 needed by rubygem-rspec-fire-1.3.0-1.el8.noarch
  - nothing provides rubygem-rspec < 4 needed by rubygem-rspec-fire-1.3.0-1.el8.noarch

Comment 3 Breno 2020-02-04 18:10:36 UTC
Spec URL: https://raw.githubusercontent.com/skywalkerz0r/rubygem-rspec-fire/epel8/rubygem-rspec-fire.spec
SRPM URL: https://download.copr.fedorainfracloud.org/results/brandfbb/general-testing/epel-8-x86_64/01221429-rubygem-rspec-fire/rubygem-rspec-fire-1.3.0-1.el8.src.rpm

Hi Alejandro,

Thanks for your feedback. 
I've just corrected the spec file and according to my mock tests, it's all good:

$ rpmlint rubygem-rspec-fire-1.3.0-1.el8.noarch.rpm
1 packages and 0 specfiles checked; 0 errors, 0 warnings.

I updated the URL above (using the raw spec file as you told me to :)


Thanks.

Comment 4 Alejandro Alvarez 2020-02-05 09:37:30 UTC
Hello again,

Here is the review. There are three issues:

* You must require rubygems on your doc package, specially because it is the owner of /usr/share/gems/ and /usr/share/gems/doc.
  I have checked other rubygem doc packages and they do depend on rubygems, so better add it.

* You can get rid of your Requires. See https://docs.fedoraproject.org/en-US/packaging-guidelines/Ruby/#_rubygems
  This is optional

* There are no tests, but AFAIK upstream has none, so little to do here.


Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- gems should require rubygems package
  Note: Requires: rubygems missing in rubygem-rspec-fire-doc
  See: https://docs.fedoraproject.org/en-US/packaging-
  guidelines/Ruby/#RubyGems
  
- Package contains Requires: ruby(release).


===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: There is no build directory. Running licensecheck on vanilla
     upstream sources. No licenses found. Please check the source files for
     licenses manually.
[x]: License file installed when any subpackage combination is installed.
[!]: Package must own all directories that it creates.
     Note: Directories without known owners: /usr/share/gems,
     /usr/share/gems/doc
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: No rpmlint messages.
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package must not depend on deprecated() packages.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 0 bytes in 0 files.
[x]: Packages must not store files under /srv, /opt or /usr/local

Ruby:
[x]: Platform dependent files must all go under %{gem_extdir_mri}, platform
     independent under %{gem_dir}.
[x]: Gem package must not define a non-gem subpackage
[x]: Macro %{gem_extdir} is deprecated.
[x]: Gem package is named rubygem-%{gem_name}
[x]: Package contains BuildRequires: rubygems-devel.
[x]: Gem package must define %{gem_name} macro.
[x]: Pure Ruby package must be built as noarch
[x]: Package does not contain Requires: ruby(abi).

===== SHOULD items =====

Generic:
[ ]: Avoid bundling fonts in non-fonts packages.
     Note: Package contains font files
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Sources are verified with gpgverify first in %prep if upstream
     publishes signatures.
     Note: gpgverify is not used.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Fully versioned dependency in subpackages if applicable.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

Ruby:
[!]: Test suite of the library should be run.
    Upstream has no test suite
[x]: Gem package should exclude cached Gem.
[x]: Gem should use %gem_install macro.
[x]: Specfile should use macros from rubygem-devel package.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: rubygem-rspec-fire-1.3.0-1.el8.noarch.rpm
          rubygem-rspec-fire-doc-1.3.0-1.el8.noarch.rpm
          rubygem-rspec-fire-1.3.0-1.el8.src.rpm
3 packages and 0 specfiles checked; 0 errors, 0 warnings.




Rpmlint (installed packages)
----------------------------
Cannot parse rpmlint output:


Source checksums
----------------
https://rubygems.org/gems/rspec-fire-1.3.0.gem :
  CHECKSUM(SHA256) this package     : 4e261ed18e711b479cf926d6e0494784094e6a7e3e74a0c0b8797c98a0c9fc3c
  CHECKSUM(SHA256) upstream package : 4e261ed18e711b479cf926d6e0494784094e6a7e3e74a0c0b8797c98a0c9fc3c


Requires
--------
rubygem-rspec-fire (rpmlib, GLIBC filtered):
    (rubygem(rspec) < 4 with rubygem(rspec) >= 2.11)
    ruby
    ruby(rubygems)
    rubygem-rake
    rubygem-rspec
    rubygems

rubygem-rspec-fire-doc (rpmlib, GLIBC filtered):
    rubygem-rspec-fire



Provides
--------
rubygem-rspec-fire:
    rubygem(rspec-fire)
    rubygem-rspec-fire

rubygem-rspec-fire-doc:
    rubygem-rspec-fire-doc



Generated by fedora-review 0.7.4 (54fa030) last change: 2019-12-07
Command line :/usr/bin/fedora-review -b 1794229 -o-r epel-8-x86_64
Buildroot used: fedora-rawhide-x86_64
Active plugins: Shell-api, Generic, Ruby
Disabled plugins: Python, Perl, Java, C/C++, SugarActivity, Ocaml, R, Haskell, PHP, fonts
Disabled flags: EPEL6, EPEL7, DISTTAG, BATCH, EXARCH

Comment 5 Breno 2020-02-06 15:46:01 UTC
Spec URL: https://raw.githubusercontent.com/skywalkerz0r/rubygem-rspec-fire/epel8/rubygem-rspec-fire.spec
SRPM URL: https://download.copr.fedorainfracloud.org/results/brandfbb/puppet-6-on-EPEL-8-with-deps/epel-8-x86_64/01223578-rubygem-rspec-fire/rubygem-rspec-fire-1.3.0-1.el8.src.rpm

Hi Alejandro,

Thanks again :)

I updated the URLs above and also ran the fedora-review myself (I should have done that in the first place, heh :)


- B

Comment 6 Alejandro Alvarez 2020-02-06 16:00:48 UTC
Looks good to me!

Comment 7 Gwyn Ciesla 2020-02-06 17:00:48 UTC
(fedscm-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/rubygem-rspec-fire

Comment 8 Fedora Update System 2020-02-06 19:01:47 UTC
FEDORA-EPEL-2020-c798c7399f has been submitted as an update to Fedora EPEL 8. https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2020-c798c7399f

Comment 9 Fedora Update System 2020-02-07 03:09:28 UTC
rubygem-rspec-fire-1.3.0-1.el8 has been pushed to the Fedora EPEL 8 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2020-c798c7399f

Comment 10 Fedora Update System 2020-02-22 02:35:01 UTC
rubygem-rspec-fire-1.3.0-1.el8 has been pushed to the Fedora EPEL 8 stable repository. If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.